net.sf.saxon.expr

## Class Literal

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.Literal

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, InstructionInfo, Locator
  Direct Known Subclasses:
    FunctionLiteral, StringLiteral

      public class Literal
      extends Expression

  A Literal is an expression whose value is constant: it is a class that implements the `Expression` interface as a wrapper around a `GroundedValue`. This may derive from an actual literal in an XPath expression or query, or it may be the result of evaluating a constant subexpression such as true() or xs:date('2007-01-16')
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Literal(GroundedValue value)` Create a literal as a wrapper around a Value

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
    `int` | `computeCardinality()` Determine the cardinality
    `int` | `computeSpecialProperties()` Compute the static properties of this expression (other than its type).
    `Expression` | `copy()` Copy an expression.
    `boolean` | `effectiveBooleanValue(XPathContext context)` Get the effective boolean value of the expression.
    `boolean` | `equals(Object obj)` Determine whether two literals are equal, when considered as expressions.
    `CharSequence` | `evaluateAsString(XPathContext context)` Evaluate an expression as a String.
    `Item` | `evaluateItem(XPathContext context)` Evaluate as a singleton item (or empty sequence).
    `void` | `evaluatePendingUpdates(XPathContext context, PendingUpdateList pul)` Evaluate an updating expression, adding the results to a Pending Update List.
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `int` | `getDependencies()` Determine which aspects of the context the expression depends on.
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the Literal expression
    `IntegerValue[]` | `getIntegerBounds()` For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
    `ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items in the expression, if possible
    `int` | `getStreamability(int syntacticContext, boolean allowExtensions, List<String> reasons)` Get the "sweep" of this expression as defined in the W3C streamability specifications.
    `GroundedValue` | `getValue()` Get the value represented by this Literal
    `int` | `hashCode()` Return a hash code to support the equals() function
    `static boolean` | `isAtomic(Expression exp)` Test whether the literal wraps an atomic value.
    `static boolean` | `isConstantBoolean(Expression exp, boolean value)` Test if a literal represents the boolean value true
    `static boolean` | `isConstantOne(Expression exp)` Test if a literal represents the integer value 1
    `static boolean` | `isEmptySequence(Expression exp)` Test whether the literal explicitly wraps an empty sequence.
    `boolean` | `isSubtreeExpression()` Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
    `boolean` | `isVacuousExpression()` Determine whether this is a vacuous expression as defined in the XQuery update specification
    `SequenceIterator<? extends Item>` | `iterate()` Return an Iterator to iterate over the values of a sequence.
    `SequenceIterator<? extends Item>` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
    `static Literal` | `makeEmptySequence()` Factory method to make an empty-sequence literal
    `static Literal` | `makeLiteral(GroundedValue value)` Factory method to create a literal as a wrapper around a Value (factory method)
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Optimize an expression
    `void` | `process(XPathContext context)` Process the value as an instruction, without returning any tail calls
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression
    `Pattern` | `toPattern(Configuration config, boolean is30)` Convert this expression to an equivalent XSLT pattern
    `Pattern` | `toStreamingPattern(Configuration config, List<String> reasonForFailure)` Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)
    `String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` TypeCheck an expression

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getEvaluationMethod, getExecutable, getExpressionName, getHostLanguage, getImplementationMethod, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamingAdjunct, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isUpdatingExpression, iterateEvents, iterateSubExpressionInfo, iterateSubExpressions, markTailFunctionCalls, promote, replaceSubExpression, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Literal

          protected Literal(GroundedValue value)

      Create a literal as a wrapper around a Value
      Parameters:
        `value` - the value of this literal

  - ### Method Detail

    - #### getValue

          public GroundedValue getValue()

      Get the value represented by this Literal
      Returns:
        the constant value

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Simplify an expression
      Overrides:
        `simplify` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        for a Value, this always returns the value unchanged
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      TypeCheck an expression
      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        for a Value, this always returns the value unchanged
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Optimize an expression
      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        for a Value, this always returns the value unchanged
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Determine the data type of the items in the expression, if possible
      Specified by:
        `getItemType` in class `Expression`
      Parameters:
        `th` - The TypeHierarchy. Can be null if the target is an AtomicValue.
      Returns:
        for the default implementation: AnyItemType (not known)

    - #### computeCardinality

          public int computeCardinality()

      Determine the cardinality
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Compute the static properties of this expression (other than its type). For a Value, the only special property is `StaticProperty.NON_CREATIVE`.
      Overrides:
        `computeSpecialProperties` in class `Expression`
      Returns:
        the value `StaticProperty.NON_CREATIVE`

    - #### getIntegerBounds

          public IntegerValue[] getIntegerBounds()

      For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.
      Overrides:
        `getIntegerBounds` in class `Expression`
      Returns:
        the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

    - #### isVacuousExpression

          public boolean isVacuousExpression()

      Determine whether this is a vacuous expression as defined in the XQuery update specification
      Overrides:
        `isVacuousExpression` in class `Expression`
      Returns:
        true if this expression is vacuous

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### toPattern

          public Pattern toPattern(Configuration config,
                          boolean is30)
                            throws XPathException

      Convert this expression to an equivalent XSLT pattern
      Overrides:
        `toPattern` in class `Expression`
      Parameters:
        `config` - the Saxon configuration
        `is30` - true if this is XSLT 3.0
      Returns:
        the equivalent pattern
      Throws:
        `XPathException` - if conversion is not possible

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                            PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.
      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the set of nodes within the path map
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression

    - #### getDependencies

          public final int getDependencies()

      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as StaticProperty.VARIABLES and StaticProperty.CURRENT_NODE
      Overrides:
        `getDependencies` in class `Expression`
      Returns:
        for a Value, this always returns zero.

    - #### iterate

          public SequenceIterator<? extends Item> iterate(XPathContext context)
                                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterate

          public SequenceIterator<? extends Item> iterate()
                                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### evaluateItem

          public Item evaluateItem(XPathContext context)
                            throws XPathException

      Evaluate as a singleton item (or empty sequence). Note: this implementation returns the first item in the sequence. The method should not be used unless appropriate type-checking has been done to ensure that the value will be a singleton.
      Overrides:
        `evaluateItem` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### process

          public void process(XPathContext context)
                       throws XPathException

      Process the value as an instruction, without returning any tail calls
      Overrides:
        `process` in class `Expression`
      Parameters:
        `context` - The dynamic context, giving access to the current node, the current variables, etc.
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### evaluateAsString

          public CharSequence evaluateAsString(XPathContext context)
                                        throws XPathException

      Description copied from class: `Expression`
      Evaluate an expression as a String. This function must only be called in contexts where it is known that the expression will return a single string (or where an empty sequence is to be treated as a zero-length string). Implementations should not attempt to convert the result to a string, other than converting () to "". This method is used mainly to evaluate expressions produced by compiling an attribute value template.
      Overrides:
        `evaluateAsString` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue(XPathContext context)
                                        throws XPathException

      Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.
      Overrides:
        `effectiveBooleanValue` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates(XPathContext context,
                                    PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException. The implementation for a literal representing an empty sequence, however, is a no-op.
      Overrides:
        `evaluatePendingUpdates` in class `Expression`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails

    - #### equals

          public boolean equals(Object obj)

      Determine whether two literals are equal, when considered as expressions.
      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the other expression
      Returns:
        true if the two literals are equal. The test here requires (a) identity in the sense defined by XML Schema (same value in the same value space), and (b) identical type annotations. For example the literal xs:int(3) is not equal (as an expression) to xs:short(3), because the two expressions are not interchangeable.

    - #### hashCode

          public int hashCode()

      Return a hash code to support the equals() function
      Overrides:
        `hashCode` in class `Object`

    - #### toString

          public String toString()

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax
      Overrides:
        `toString` in class `Expression`
      Returns:
        a representation of the expression as a string

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

    - #### isAtomic

          public static boolean isAtomic(Expression exp)

      Test whether the literal wraps an atomic value. (Note, if this method returns false, this still leaves the possibility that the literal wraps a sequence that happens to contain a single atomic value).
      Parameters:
        `exp` - an expression
      Returns:
        true if the expression is a literal and the literal wraps an AtomicValue

    - #### isEmptySequence

          public static boolean isEmptySequence(Expression exp)

      Test whether the literal explicitly wraps an empty sequence. (Note, if this method returns false, this still leaves the possibility that the literal wraps a sequence that happens to be empty).
      Parameters:
        `exp` - an expression
      Returns:
        true if the expression is a literal and the value of the literal is an empty sequence

    - #### isConstantBoolean

          public static boolean isConstantBoolean(Expression exp,
                                  boolean value)

      Test if a literal represents the boolean value true
      Parameters:
        `exp` - an expression
        `value` - true or false
      Returns:
        true if the expression is a literal and the literal represents the boolean value given in the second argument

    - #### isConstantOne

          public static boolean isConstantOne(Expression exp)

      Test if a literal represents the integer value 1
      Parameters:
        `exp` - an expression
      Returns:
        true if the expression is a literal and the literal represents the integer value 1

    - #### isSubtreeExpression

          public boolean isSubtreeExpression()

      Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
      Overrides:
        `isSubtreeExpression` in class `Expression`
      Returns:
        true if the expression has no dependencies on the context node, or if the only dependencies on the context node are downward selections using the self, child, descendant, attribute, and namespace axes.

    - #### makeEmptySequence

          public static Literal makeEmptySequence()

      Factory method to make an empty-sequence literal
      Returns:
        a literal whose value is the empty sequence

    - #### makeLiteral

          public static Literal makeLiteral(GroundedValue value)

      Factory method to create a literal as a wrapper around a Value (factory method)
      Parameters:
        `value` - the value of this literal
      Returns:
        the Literal

    - #### toStreamingPattern

          public Pattern toStreamingPattern(Configuration config,
                                   List<String> reasonForFailure)

      Convert this expression to a streaming pattern (a pattern used internally to match nodes during push processing of an event stream)
      Overrides:
        `toStreamingPattern` in class `Expression`
      Parameters:
        `config` - the Saxon configuration
        `reasonForFailure` - a list which will be populated with messages giving reasons why the expression cannot be converted
      Returns:
        the equivalent pattern if conversion succeeds; otherwise null

    - #### getStreamability

          public int getStreamability(int syntacticContext,
                             boolean allowExtensions,
                             List<String> reasons)

      Description copied from class: `Expression`
      Get the "sweep" of this expression as defined in the W3C streamability specifications. This provides an assessment of stylesheet code against the W3C criteria for guaranteed streamability, and is implemented to allow these criteria to be tested. It is not the case that all expression that emerge as streamable from this analysis are currently capable of being streamed by Saxon
      Overrides:
        `getStreamability` in class `Expression`
      Parameters:
        `syntacticContext` - one of the values `Expression.NAVIGATION_CONTEXT`, `Expression.NODE_VALUE_CONTEXT`, `Expression.INHERITED_CONTEXT`, `Expression.INSPECTION_CONTEXT`
        `allowExtensions` - if false, the definition of "guaranteed streamability" in the W3C specification is used. If true, Saxon extensions are permitted, which make some
        `reasons` - the caller may supply a list, in which case the implementation may add to this list a message explaining why the construct is not streamable, suitable for inclusion in an error message.
      Returns:
        one of the values `Expression.W3C_MOTIONLESS`, `Expression.W3C_CONSUMING`, `Expression.W3C_GROUP_CONSUMING`, `Expression.W3C_FREE_RANGING`

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the Literal expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.